﻿/*
 * EchoService.cs
 *
 * Author Michael Claudius, ZIBAT Computer Science
 * Version 1.0. 2014.02.10
 * Copyright 2014 by Michael Claudius
 * Revised 2014.09.11, 2016.03.01
 * All rights reserved
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Sockets;
using System.IO;
using System.Threading;

namespace SocketConcurrent
{
    class EchoService
    {
        private TcpClient connectionSocket;
        private TcpListener serverSocket;
        String uri = @"C:/D Drive/Undervisning";
        FileStream fileStream;

        public EchoService(TcpClient connectionSocket)
        {
            // TODO: Complete member initialization
            this.connectionSocket = connectionSocket;
        }

        public EchoService(ref TcpClient connectionSocket,ref TcpListener serverSocket)
        {
            // TODO: Complete member initialization
            this.connectionSocket = connectionSocket;
            this.serverSocket = serverSocket;
        }
        internal void DoIt()
        {
            Stream ns = connectionSocket.GetStream();
            StreamReader sr = new StreamReader(ns);
           // StreamWriter sw = new StreamWriter(ns);
            StreamWriter sw = new StreamWriter(new BufferedStream(ns));
            sw.AutoFlush = true; // enable automatic flushing

            string message = sr.ReadLine();
            string answer, first;
            while (message != null && message != "")
            {
                Console.WriteLine("Client: " + message);
                string[] list = message.Split(' ');
                first = list[0].ToUpper();
                if (first.Equals("STOP"))
                {
                    Console.WriteLine("Wants to stop");
                    ns.Close();
                    connectionSocket.Close();
                    while (serverSocket.Pending())
                        Thread.Sleep(100);
                    Console.WriteLine("Shutdown says; Server is stopped");
                   
                    serverSocket.Stop();                       
                    break;
                }

                if (first.Equals("GET") && list.Length==3)
                {
                    string fileName = list[1];
                    string protocol = list[2];

                    //Ass. 2
                    
                   //sw.WriteLine("Requested file: " + fileName);

                    //Ass. 3
                    sw.Write("HTTP/1.1 200 OK\r\n");
                    sw.Write("Content-Type: text/html\r\n");
                    sw.Write("Connection: close\r\n");
                    sw.Write("\r\n"); //Only to Browser marks data are coming
                    sw.Write("Hello client\r\n");
                    sw.Write("Requested file: " + fileName+"\r\n");
                   //sw.Write("\r\n"); //Only to Browser data are coming
                  
                    //sw.Flush();
                    //sw.BaseStream.Flush();
                    //sw.Close();  //Only to Browser
                                 // break;

                    //Ass. 5

                    uri = uri + fileName;

                    fileStream = new FileStream(uri, FileMode.Open, FileAccess.Read);
                    StreamReader fileReader = new StreamReader(fileStream);
                    while (!fileReader.EndOfStream)
                    {
                        string s = fileReader.ReadLine();
                        Console.WriteLine(s);
                        sw.Write(s +"\r\n");
                    }
                    sw.Write("\r\n");
                    sw.Flush();
                   sw.BaseStream.Flush();
                    sw.Close();

                }
                else
                {
                    answer = message.ToUpper();
                    sw.WriteLine(answer);
                }
                // sw.Flush();
                message = sr.ReadLine();

            }
            //ns.Close();
            //connectionSocket.Close();
        }
    }
}

